<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item label="供应商" prop="supplierId" v-if="ifAlone==null">
        <el-input
          v-model="queryParams.supplierId"
          placeholder="请输入供应商"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="产品名称" prop="productName">
        <el-input
          v-model="queryParams.productName"
          placeholder="请输入产品名称"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="创建时间" prop="createTime">
        <el-date-picker
          v-model="queryParams.createTime"
          value-format="YYYY-MM-DD HH:mm:ss"
          type="daterange"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
          class="!w-220px"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        <el-button
          v-if="!isDetail"
          type="primary"
          plain
          @click="openForm('create')"
        >
          <Icon icon="ep:plus" class="mr-5px" /> 新增
        </el-button>
        <el-button
          v-if="!isDetail"
          type="success"
          plain
          @click="handleExport"
          :loading="exportLoading"
        >
          <Icon icon="ep:download" class="mr-5px" /> 导出
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
      <el-table-column label="供应商" align="center" prop="supplierId" >
        <template #default="scope">
          <span>{{ supplierList.find((item) => item.id === scope.row.supplierId)?.name }}</span>
        </template>
      </el-table-column>
      <el-table-column label="产品名称" align="center" prop="productId" >
        <template #default="scope">
          <span>{{ productList.find((item) => item.id === scope.row.productId)?.name }}</span>
        </template>
      </el-table-column>
      <el-table-column label="优势介绍" align="center" prop="advantage" />
      <el-table-column
        label="创建时间"
        align="center"
        prop="createTime"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column label="操作" v-if="!isDetail" align="center" min-width="120px">
        <template #default="scope">
          <el-button
            link
            type="primary"
            @click="openForm('update', scope.row.id)"

          >
            编辑
          </el-button>
          <el-button
            link
            type="danger"
            @click="handleDelete(scope.row.id)"

          >
            删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <CoreProductForm ref="formRef" :supplierId="{ receivedParam }" :ifAlone="ifAlone" @success="getList" />
  <el-form v-if="ifAlone!= null">
    <el-form-item style="float: right">
      <el-button type="primary" @click="close">返回</el-button>
    </el-form-item>
  </el-form>
</template>

<script setup lang="ts">
import { dateFormatter } from '@/utils/formatTime'
import download from '@/utils/download'
import { CoreProductApi, CoreProductVO } from '@/api/supplier/coreproduct'
import CoreProductForm from './CoreProductForm.vue'
import * as SupplierBaseApi from "@/api/supplier/base";
import {SupplierVO} from "@/api/supplier/base";
import * as SupplierDetailApi from "@/api/supplier/product/supplierdetail";
import { propTypes } from '@/utils/propTypes'
import {useTagsViewStore} from "@/store/modules/tagsView";
import {SupplierProductVo} from "@/api/supplier/product/supplierdetail";
const { delView } = useTagsViewStore() // 视图操作
const { push, currentRoute } = useRouter() // 路由
/** 供应商核心产品 列表 */
defineOptions({ name: 'CoreProduct' })

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化
const props = defineProps({
  isDetail: propTypes.bool.def(false), // 是否作为详情组件
  ifAlone: {type:Boolean, default:()=>null},
  receivedParam: { type: undefined, default: () => null }
})
const loading = ref(true) // 列表的加载中
const list = ref<CoreProductVO[]>([]) // 列表的数据
const supplierList = ref([] as SupplierVO[])
const productList = ref([] as SupplierProductVo[])
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  supplierId: undefined,
  productId: undefined,
  productName: undefined,
  advantage: undefined,
  createTime: [],
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

/** 查询列表 */
const getList = async () => {
  supplierList.value = await SupplierBaseApi.Api.getAll()
  loading.value = true
  try {
    if (props.ifAlone!=null) {
      queryParams.supplierId = props.receivedParam === null?'0000000000':props.receivedParam
    }
    const data = await CoreProductApi.getCoreProductPage(queryParams)
    list.value = data.list
    total.value = data.total
    queryParams.supplierId = undefined
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = async () => {
  queryParams.pageNo = 1
  await getList()
  supplierList.value = await SupplierBaseApi.Api.getAll()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await CoreProductApi.deleteCoreProduct(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await CoreProductApi.exportCoreProduct(queryParams)
    download.excel(data, '供应商核心产品.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 初始化 **/
onMounted(async () => {
  await getList()
  supplierList.value = await SupplierBaseApi.Api.getAll()
  productList.value = await SupplierDetailApi.getAll()
})
const close = () => {
  delView(unref(currentRoute))
  push({ name: 'Suppliers',query: {
      date: new Date().getTime(),
    } })
}
</script>
